/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  lpickstk.h

\***************************************************************************/


#if !defined(LPICKSTK_H)
#define LPICKSTK_H

#if !defined(LPIERROR_H)
#include "lpierror.h"
#endif

extern int cdecl StackStatus(void);

#define StackOverflow   (LPI_S_STACK_OVERFLOW)     /* stack overflow trap */

#define CheckStackStatus if(StackStatus())return(StackOverflow)

/* the following is for 1-2-3 version checking */
lptr(lubyte) get_123_ver(lptr(CONTEXT));

/*
- Macro:       is_r30
-
- Description: Return true if the core product is 1-2-3 version 3.00.00.
-              (strcmp returns 0 if strings are identical.)
-
*/

#define is_r30() (!strcmp(get_123_ver(LpiContext), "3.00.00"))


#endif  /* LPICKSTK_H */

