/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  sheet.plx

\***************************************************************************/

#if !defined(SHEET_PLX)
#define SHEET_PLX
#define ll3sheet_name "SHEET"           /* name of primitive module */
/* SPR #121344 */
#define LPI_SH_MAXZERO_BUFLEN   512     /* for LpiShSetZero: maximum length
                                        ** of set-string, includes final '\0'.
                                        */
/* Argument defines for C-callable functions */
#define LPI_SH_DEST_ARGS\
 (lptr(CONTEXT) LpiContext,\
 lptr(LpiSheetType) inst_mptr)
#define LPI_SH_CONST_CURRENT_ARGS\
 (lptr(CONTEXT) LpiContext,\
 lptr(LpiSheetType) sht_mptr)
#define LPI_SH_CONST_NUMBER_ARGS\
 (lptr(CONTEXT) LpiContext,\
 lptr(LpiSheetType) sht_mptr,\
 lslong sheet_number)
#define LPI_SH_CONST_FILE_ARGS\
 (lptr(CONTEXT) LpiContext,\
 lptr(LpiSheetType) sht_mptr,\
 lmhdl(lmbcs) pwkfilename,\
 lslong sheet_number)
#define LPI_SH_STRING_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType msheet,\
 lptr(lmhdl(lmbcs)) p_theString)
#define LPI_SH_LAST_CELL_STRING_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType msheet,\
 lptr(lmhdl(lmbcs)) p_theString)
#define LPI_SH_LAST_CELL_COORDS_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType msheet,\
 lptr(lmhdl(lmbcs)) p_theString,\
 lptr(lushort) sheet_num,\
 lptr(lushort) col_num,\
 lptr(lushort) row_num)
#define LPI_SH_GET_POSITION_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lptr(lushort) sheetcoord)
#define LPI_SH_GET_FNAME_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lptr(lmhdl(lmbcs)) fname)
#define LPI_SH_SET_COLWIDTH_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lslong col_width,\
 lushort window)
#define LPI_SH_GET_COLWIDTH_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lptr(lushort) col_width,\
 lushort window)
#define LPI_SH_GET_LABELPREF_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lptr(lushort) prefixval)
#define LPI_SH_SET_LABELPREF_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lushort prefixval)
#define LPI_SH_GET_ZERO_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lptr(lmhdl(lmbcs)) buffmptr)
#define LPI_SH_SET_ZERO_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lmhdl(lmbcs) mstring)
#define LPI_SH_SET_HIDDEN_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lbool hide)
#define LPI_SH_GET_HIDDEN_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lptr(lbool) hidden)
#define LPI_SH_GET_PROTECTION_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lptr(lbool) protected)
#define LPI_SH_SET_PROTECTION_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lbool protected)
#define LPI_SH_GET_TITLES_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lptr(lushort) titlecols,\
 lptr(lushort) titlerows,\
 lushort window)
#define LPI_SH_SET_TITLES_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lslong cols,\
 lslong numrows,\
 lushort window)
#define LPI_SH_SET_TITLES_NONE_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lushort window)
#define LPI_SH_SET_FORMAT_PLACES_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lushort dec_format,\
 lushort dec_places)
#define LPI_SH_SET_FORMAT_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lushort other_fmt)
#define LPI_SH_GET_FORMAT_PLACES_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lptr(lushort) fmt,\
 lptr(lushort) dec_places)
#define LPI_SH_GET_FORMAT_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lptr(lushort) fmt)
#define LPI_SH_INSERT_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lushort start_unit,\
 lushort num_units,\
 lushort flag,\
 lptr(lushort) err)
#define LPI_SH_DELETE_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiSheetType in_sheet,\
 lushort start_unit,\
 lushort num_units,\
 lushort flag,\
 lptr(lushort) err)
/* Prototypes for C callable functions */
lexppro (lsshort, lpi_sh_dest, LPI_SH_DEST_ARGS);
lexppro (lsshort, lpi_sh_const_current, LPI_SH_CONST_CURRENT_ARGS);
lexppro (lsshort, lpi_sh_const_number, LPI_SH_CONST_NUMBER_ARGS);
lexppro (lsshort, lpi_sh_const_file, LPI_SH_CONST_FILE_ARGS);
lexppro (lsshort, lpi_sh_string, LPI_SH_STRING_ARGS);
lexppro (lsshort, lpi_sh_last_cell_string, LPI_SH_LAST_CELL_STRING_ARGS);
lexppro (lsshort, lpi_sh_last_cell_coords, LPI_SH_LAST_CELL_COORDS_ARGS);
lexppro (lsshort, lpi_sh_get_position, LPI_SH_GET_POSITION_ARGS);
lexppro (lsshort, lpi_sh_get_fname, LPI_SH_GET_FNAME_ARGS);
lexppro (lsshort, lpi_sh_set_colwidth, LPI_SH_SET_COLWIDTH_ARGS);
lexppro (lsshort, lpi_sh_get_colwidth, LPI_SH_GET_COLWIDTH_ARGS);
lexppro (lsshort, lpi_sh_get_labelpref, LPI_SH_GET_LABELPREF_ARGS);
lexppro (lsshort, lpi_sh_set_labelpref, LPI_SH_SET_LABELPREF_ARGS);
lexppro (lsshort, lpi_sh_get_zero, LPI_SH_GET_ZERO_ARGS);
lexppro (lsshort, lpi_sh_set_zero, LPI_SH_SET_ZERO_ARGS);
lexppro (lsshort, lpi_sh_set_hidden, LPI_SH_SET_HIDDEN_ARGS);
lexppro (lsshort, lpi_sh_get_hidden, LPI_SH_GET_HIDDEN_ARGS);
lexppro (lsshort, lpi_sh_get_protection, LPI_SH_GET_PROTECTION_ARGS);
lexppro (lsshort, lpi_sh_set_protection, LPI_SH_SET_PROTECTION_ARGS);
lexppro (lsshort, lpi_sh_get_titles, LPI_SH_GET_TITLES_ARGS);
lexppro (lsshort, lpi_sh_set_titles, LPI_SH_SET_TITLES_ARGS);
lexppro (lsshort, lpi_sh_set_titles_none, LPI_SH_SET_TITLES_NONE_ARGS);
lexppro (lsshort, lpi_sh_set_format_places, LPI_SH_SET_FORMAT_PLACES_ARGS);
lexppro (lsshort, lpi_sh_set_format, LPI_SH_SET_FORMAT_ARGS);
lexppro (lsshort, lpi_sh_get_format_places, LPI_SH_GET_FORMAT_PLACES_ARGS);
lexppro (lsshort, lpi_sh_get_format, LPI_SH_GET_FORMAT_ARGS);
lexppro (lsshort, lpi_sh_insert, LPI_SH_INSERT_ARGS);
lexppro (lsshort, lpi_sh_delete, LPI_SH_DELETE_ARGS);
/* pointers to C callable functions */
typedef struct {
  lexpptr(lsshort, lpi_sh_const_current, LPI_SH_CONST_CURRENT_ARGS);
  lexpptr(lsshort, lpi_sh_const_number, LPI_SH_CONST_NUMBER_ARGS);
  lexpptr(lsshort, lpi_sh_const_file, LPI_SH_CONST_FILE_ARGS);
  lexpptr(lsshort, lpi_sh_dest, LPI_SH_DEST_ARGS);
  lexpptr(lsshort, lpi_sh_string, LPI_SH_STRING_ARGS);
  lexpptr(lsshort, lpi_sh_last_cell_string, LPI_SH_LAST_CELL_STRING_ARGS);
  lexpptr(lsshort, lpi_sh_last_cell_coords, LPI_SH_LAST_CELL_COORDS_ARGS);
  lexpptr(lsshort, lpi_sh_get_position, LPI_SH_GET_POSITION_ARGS);
  lexpptr(lsshort, lpi_sh_get_fname, LPI_SH_GET_FNAME_ARGS);
  lexpptr(lsshort, lpi_sh_set_colwidth, LPI_SH_SET_COLWIDTH_ARGS);
  lexpptr(lsshort, lpi_sh_get_colwidth, LPI_SH_GET_COLWIDTH_ARGS);
  lexpptr(lsshort, lpi_sh_get_labelpref, LPI_SH_GET_LABELPREF_ARGS);
  lexpptr(lsshort, lpi_sh_set_labelpref, LPI_SH_SET_LABELPREF_ARGS);
  lexpptr(lsshort, lpi_sh_get_zero, LPI_SH_GET_ZERO_ARGS);
  lexpptr(lsshort, lpi_sh_set_zero, LPI_SH_SET_ZERO_ARGS);
  lexpptr(lsshort, lpi_sh_set_hidden, LPI_SH_SET_HIDDEN_ARGS);
  lexpptr(lsshort, lpi_sh_get_hidden, LPI_SH_GET_HIDDEN_ARGS);
  lexpptr(lsshort, lpi_sh_get_protection, LPI_SH_GET_PROTECTION_ARGS);
  lexpptr(lsshort, lpi_sh_set_protection, LPI_SH_SET_PROTECTION_ARGS);
  lexpptr(lsshort, lpi_sh_get_titles, LPI_SH_GET_TITLES_ARGS);
  lexpptr(lsshort, lpi_sh_set_titles, LPI_SH_SET_TITLES_ARGS);
  lexpptr(lsshort, lpi_sh_set_titles_none, LPI_SH_SET_TITLES_NONE_ARGS);
  lexpptr(lsshort, lpi_sh_set_format_places, LPI_SH_SET_FORMAT_PLACES_ARGS);
  lexpptr(lsshort, lpi_sh_set_format, LPI_SH_SET_FORMAT_ARGS);
  lexpptr(lsshort, lpi_sh_get_format_places, LPI_SH_GET_FORMAT_PLACES_ARGS);
  lexpptr(lsshort, lpi_sh_get_format, LPI_SH_GET_FORMAT_ARGS);
  lexpptr(lsshort, lpi_sh_insert, LPI_SH_INSERT_ARGS);
  lexpptr(lsshort, lpi_sh_delete, LPI_SH_DELETE_ARGS);
} sh_exports;
#if defined(LPIXPORT_H) /* macros to call the structure stuff */
/* 1-2-3 display window (primary/secondary) selectors */
#if !defined(WINDOW_1)
#define WINDOW_1        1
#endif
#if !defined(WINDOW_2)
#define WINDOW_2        2
#endif
#if defined(NOGLOBALDATA)
#define LPI_SH_GLOBAL_REF  LPI_CALL_DATA->sh_global
#define LPI_SH_TABLE_REF   LPI_CALL_DATA->sh_table
#else
#define LPI_SH_GLOBAL_REF  lts_sh_global
#define LPI_SH_TABLE_REF   lts_sh_table
#endif
#define LpiShConstructCurrent(xdata)\
        (*LPI_SH_TABLE_REF->lpi_sh_const_current) (LPI_SH_GLOBAL_REF, xdata)
#define LpiShConstructNumber(xADTdata, arg1)\
        (*LPI_SH_TABLE_REF->lpi_sh_const_number) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShConstructFileNumber(xADTdata, arg1, arg2)\
        (*LPI_SH_TABLE_REF->lpi_sh_const_file) (LPI_SH_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiShDestroy(xADTdata)\
        (*LPI_SH_TABLE_REF->lpi_sh_dest) (LPI_SH_GLOBAL_REF, xADTdata )
#define LpiShString(xADTdata, arg1)\
        (*LPI_SH_TABLE_REF->lpi_sh_string) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShLastCellString(xADTdata, arg1)\
        (*LPI_SH_TABLE_REF->lpi_sh_last_cell_string) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShLastCellCoords(xADTdata, arg1, arg2, arg3, arg4)\
        (*LPI_SH_TABLE_REF->lpi_sh_last_cell_coords) (LPI_SH_GLOBAL_REF, xADTdata, arg1, arg2, arg3, arg4)
#define LpiShGetPosition(xADTdata, arg1 )\
        (*LPI_SH_TABLE_REF->lpi_sh_get_position) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShGetFileName(xADTdata, arg1 )\
        (*LPI_SH_TABLE_REF->lpi_sh_get_fname) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShSetColumnWidth(xADTdata, arg1)\
        (*LPI_SH_TABLE_REF->lpi_sh_set_colwidth) (LPI_SH_GLOBAL_REF, xADTdata, arg1, WINDOW_1)
#define LpiShSetColumnWidthWin(xADTdata, arg1, arg2)\
        (*LPI_SH_TABLE_REF->lpi_sh_set_colwidth) (LPI_SH_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiShGetColumnWidth(xADTdata, arg1)\
        (*LPI_SH_TABLE_REF->lpi_sh_get_colwidth) (LPI_SH_GLOBAL_REF, xADTdata, arg1, WINDOW_1)
#define LpiShGetColumnWidthWin(xADTdata, arg1, arg2)\
        (*LPI_SH_TABLE_REF->lpi_sh_get_colwidth) (LPI_SH_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiShGetLabelPrefix(xADTdata, arg1)\
        (*LPI_SH_TABLE_REF->lpi_sh_get_labelpref) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShSetLabelPrefix(xADTdata, arg1)\
        (*LPI_SH_TABLE_REF->lpi_sh_set_labelpref) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShGetZero(xADTdata, arg1)\
        (*LPI_SH_TABLE_REF->lpi_sh_get_zero) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShSetZero(xADTdata, arg1 )\
        (*LPI_SH_TABLE_REF->lpi_sh_set_zero) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShSetHidden(xADTdata, arg1)\
        (*LPI_SH_TABLE_REF->lpi_sh_set_hidden) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShGetHidden(xADTdata, arg1)\
        (*LPI_SH_TABLE_REF->lpi_sh_get_hidden) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShGetProtection(xADTdata, arg1)\
        (*LPI_SH_TABLE_REF->lpi_sh_get_protection) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShSetProtection(xADTdata, arg1)\
        (*LPI_SH_TABLE_REF->lpi_sh_set_protection) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShGetTitles(xADTdata, arg1,arg2)\
        (*LPI_SH_TABLE_REF->lpi_sh_get_titles) (LPI_SH_GLOBAL_REF, xADTdata, arg1,arg2, WINDOW_1 )
#define LpiShGetTitlesWin(xADTdata, arg1,arg2,arg3 )\
        (*LPI_SH_TABLE_REF->lpi_sh_get_titles) (LPI_SH_GLOBAL_REF, xADTdata, arg1,arg2,arg3 )
#define LpiShSetTitlesVert(xADTdata, arg1 )\
        (*LPI_SH_TABLE_REF->lpi_sh_set_titles) (LPI_SH_GLOBAL_REF, xADTdata, arg1, 0L, WINDOW_1 )
#define LpiShSetTitlesVertWin(xADTdata, arg1, arg2 )\
        (*LPI_SH_TABLE_REF->lpi_sh_set_titles) (LPI_SH_GLOBAL_REF, xADTdata, arg1, 0L, arg2 )
#define LpiShSetTitlesHoriz(xADTdata, arg1 )\
        (*LPI_SH_TABLE_REF->lpi_sh_set_titles) (LPI_SH_GLOBAL_REF, xADTdata, 0L, arg1, WINDOW_1)
#define LpiShSetTitlesHorizWin(xADTdata, arg1, arg2 )\
        (*LPI_SH_TABLE_REF->lpi_sh_set_titles) (LPI_SH_GLOBAL_REF, xADTdata, 0L, arg1, arg2)
#define LpiShSetTitlesBoth(xADTdata, arg1,arg2 )\
        (*LPI_SH_TABLE_REF->lpi_sh_set_titles) (LPI_SH_GLOBAL_REF, xADTdata, arg1, arg2, WINDOW_1 )
#define LpiShSetTitlesBothWin(xADTdata, arg1,arg2,arg3 )\
        (*LPI_SH_TABLE_REF->lpi_sh_set_titles) (LPI_SH_GLOBAL_REF, xADTdata, arg1,arg2, arg3 )
#define LpiShSetTitlesNone(xADTdata )\
        (*LPI_SH_TABLE_REF->lpi_sh_set_titles_none) (LPI_SH_GLOBAL_REF, xADTdata, WINDOW_1)
#define LpiShSetTitlesNoneWin(xADTdata, arg1 )\
        (*LPI_SH_TABLE_REF->lpi_sh_set_titles_none) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShSetFormatPlaces(xADTdata,arg1,arg2)\
        (*LPI_SH_TABLE_REF->lpi_sh_set_format_places) (LPI_SH_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiShSetFormat(xADTdata, arg1)\
        (*LPI_SH_TABLE_REF->lpi_sh_set_format) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShGetFormatPlaces(xADTdata,arg1,arg2)\
        (*LPI_SH_TABLE_REF->lpi_sh_get_format_places) (LPI_SH_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiShGetFormat(xADTdata, arg1)\
        (*LPI_SH_TABLE_REF->lpi_sh_get_format) (LPI_SH_GLOBAL_REF, xADTdata, arg1)
#define LpiShInsert(xADTdata,arg1,arg2, arg3, arg4 )\
        (*LPI_SH_TABLE_REF->lpi_sh_insert) (LPI_SH_GLOBAL_REF, xADTdata,arg1,arg2, arg3, arg4 )
#define LpiShDelete(xADTdata, arg1,arg2, arg3, arg4 )\
        (*LPI_SH_TABLE_REF->lpi_sh_delete) (LPI_SH_GLOBAL_REF, xADTdata,arg1,arg2, arg3, arg4 )
#endif      /* all the exported macros */
#endif
