/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  wkspace.plx

\***************************************************************************/

#if !defined(WKSPACE_PLX)
#define WKSPACE_PLX
#define ll3wkspace_name "WKSPACE"
/* indicator list structure */
typedef struct {
                lbool calc;
                lbool calcblink;
                lbool caps;
                lbool circ;
                lbool cmd;
                lbool endkey;
                lbool file;
                lbool group;
                lbool mem;
                lbool num;
                lbool ovr;
                lbool ro;
                lbool scroll;
                lbool sst;
                lbool step;
                lbool zoom;
               } lpi_ws_indicator_list_type;
/* Argument definitions for C-callable functions */
#define LPI_WS_CONST_CURRENT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(LpiWorkspaceType) p_theWorkspace)
#define LPI_WS_DEST_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(LpiWorkspaceType) p_theWorkspace)
#define LPI_WS_CALC_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace)
#define LPI_WS_GET_CALC_ITER_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lushort) p_theIterations)
#define LPI_WS_SET_CALC_ITER_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lulong theIterations)
#define LPI_WS_GET_CALC_METHOD_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lushort) p_theMethod)
#define LPI_WS_SET_CALC_METHOD_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lushort theMethod)
#define LPI_WS_GET_CALC_ORDER_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lushort) p_theOrder)
#define LPI_WS_SET_CALC_ORDER_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lushort theOrder)
#define LPI_WS_GET_CELL_POINTER_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lmbcs) p_theFilename,\
 lptr(lushort) p_theSheet,\
 lptr(lushort) p_theColumn,\
 lptr(lushort) p_theRow)
#define LPI_WS_SET_CELL_POINTER_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lmbcs) theFilename,\
 lulong theSheet,\
 lulong theColumn,\
 lulong theRow)
#define LPI_WS_GET_CELL_TOP_LEFT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lmbcs) p_theFilename,\
 lptr(lushort) p_theSheet,\
 lptr(lushort) p_theColumn,\
 lptr(lushort) p_theRow)
#define LPI_WS_SET_CELL_TOP_LEFT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lmbcs) theFilename,\
 lulong theSheet,\
 lulong theColumn,\
 lulong theRow)
#define LPI_WS_GET_CLOCK_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lushort) p_theFormat)
#define LPI_WS_SET_CLOCK_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lushort theFormat)
#define LPI_WS_GET_CURRENT_FILE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lmbcs) p_theFilename)
#define LPI_WS_SET_CURRENT_FILE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lmbcs) theFilename)
#define LPI_WS_GET_CURRENT_SHEET_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lushort) p_theSheet)
#define LPI_WS_SET_CURRENT_SHEET_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lulong theSheet)
#define LPI_WS_GET_CURRENT_WINDOW_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lushort) p_theWindow)
#define LPI_WS_SET_CURRENT_WINDOW_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lushort theWindow)
#define LPI_WS_GET_DIRECTORY_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lmbcs) p_theDirectory)
#define LPI_WS_SET_DIRECTORY_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lmhdl(lmbcs) theDirectory)
#define LPI_WS_ERASE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lushort) p_theErrorCode)
#define LPI_WS_GET_FILE_COUNT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lushort) p_theFileCount)
#define LPI_WS_GET_FILE_NAME_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lulong thePosition,\
 lptr(lmbcs) p_theFilename)
#define LPI_WS_GET_FILE_POSITION_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lmbcs) theFilename,\
 lptr(lulong) p_thePosition)
#define LPI_WS_GET_INDICATOR_LIST_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lpi_ws_indicator_list_type) p_theIndicators)
#define LPI_WS_GET_INTL_CURRENCY_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lmbcs) p_theSign,\
 lptr(lushort) p_thePosition)
#define LPI_WS_SET_INTL_CURRENCY_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lmbcs) theSign,\
 lushort thePosition)
#define LPI_WS_GET_INTL_DATE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lushort) p_theFormat)
#define LPI_WS_SET_INTL_DATE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lushort theFormat)
#define LPI_WS_GET_INTL_NEGATIVE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lushort) p_theFormat)
#define LPI_WS_SET_INTL_NEGATIVE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lushort theFormat)
#define LPI_WS_GET_INTL_PUNC_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lushort) p_theSeparators)
#define LPI_WS_SET_INTL_PUNC_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lushort theSeparators)
#define LPI_WS_GET_INTL_TIME_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lushort) p_theFormat)
#define LPI_WS_SET_INTL_TIME_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lushort theFormat)
#define LPI_WS_GET_LIST_EXTENSION_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lmbcs) p_theExtension)
#define LPI_WS_SET_LIST_EXTENSION_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lmhdl(lmbcs) theExtension)
#define LPI_WS_GET_MEMORY_AVAIL_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lulong) p_theMemoryAvail)
#define LPI_WS_GET_RUN_AUTOEXEC_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lbool) p_theStatus)
#define LPI_WS_SET_RUN_AUTOEXEC_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lbool theStatus)
#define LPI_WS_GET_SAVE_EXTENSION_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lmbcs) p_theExtension)
#define LPI_WS_SET_SAVE_EXTENSION_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lmhdl(lmbcs) theExtension)
#define LPI_WS_STRING_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lmbcs) p_theWkspaceString)
#define LPI_WS_GET_TEMP_DIRECTORY_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lmbcs) p_theDirectory)
#define LPI_WS_SET_TEMP_DIRECTORY_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lmhdl(lmbcs) theDirectory)
#define LPI_WS_UPDATE_SETTINGS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace)
#define LPI_WS_GET_WINDOW_MODE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lushort) p_theWindowType)
#define LPI_WS_SET_WINDOW_MODE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lushort theWindowType,\
 lptr(lushort) p_theErrorCode)
#define LPI_WS_GET_WINDOW_SYNC_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lptr(lbool) p_theSetting)
#define LPI_WS_SET_WINDOW_SYNC_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWorkspaceType theWorkspace,\
 lbool theSetting)
/* C callable function typedefs */
lexppro (lsshort, lpi_ws_const_current, LPI_WS_CONST_CURRENT_ARGS);
lexppro (lsshort, lpi_ws_dest, LPI_WS_DEST_ARGS);
lexppro (lsshort, lpi_ws_calc, LPI_WS_CALC_ARGS);
lexppro (lsshort, lpi_ws_get_calc_iter, LPI_WS_GET_CALC_ITER_ARGS);
lexppro (lsshort, lpi_ws_set_calc_iter, LPI_WS_SET_CALC_ITER_ARGS);
lexppro (lsshort, lpi_ws_get_calc_method, LPI_WS_GET_CALC_METHOD_ARGS);
lexppro (lsshort, lpi_ws_set_calc_method, LPI_WS_SET_CALC_METHOD_ARGS);
lexppro (lsshort, lpi_ws_get_calc_order, LPI_WS_GET_CALC_ORDER_ARGS);
lexppro (lsshort, lpi_ws_set_calc_order, LPI_WS_SET_CALC_ORDER_ARGS);
lexppro (lsshort, lpi_ws_get_cell_pointer, LPI_WS_GET_CELL_POINTER_ARGS);
lexppro (lsshort, lpi_ws_set_cell_pointer, LPI_WS_SET_CELL_POINTER_ARGS);
lexppro (lsshort, lpi_ws_get_cell_top_left, LPI_WS_GET_CELL_TOP_LEFT_ARGS);
lexppro (lsshort, lpi_ws_set_cell_top_left, LPI_WS_SET_CELL_TOP_LEFT_ARGS);
lexppro (lsshort, lpi_ws_get_clock, LPI_WS_GET_CLOCK_ARGS);
lexppro (lsshort, lpi_ws_set_clock, LPI_WS_SET_CLOCK_ARGS);
lexppro (lsshort, lpi_ws_get_current_file, LPI_WS_GET_CURRENT_FILE_ARGS);
lexppro (lsshort, lpi_ws_set_current_file, LPI_WS_SET_CURRENT_FILE_ARGS);
lexppro (lsshort, lpi_ws_get_current_sheet, LPI_WS_GET_CURRENT_SHEET_ARGS);
lexppro (lsshort, lpi_ws_set_current_sheet, LPI_WS_SET_CURRENT_SHEET_ARGS);
lexppro (lsshort, lpi_ws_get_current_window, LPI_WS_GET_CURRENT_WINDOW_ARGS);
lexppro (lsshort, lpi_ws_set_current_window, LPI_WS_SET_CURRENT_WINDOW_ARGS);
lexppro (lsshort, lpi_ws_get_directory, LPI_WS_GET_DIRECTORY_ARGS);
lexppro (lsshort, lpi_ws_set_directory, LPI_WS_SET_DIRECTORY_ARGS);
lexppro (lsshort, lpi_ws_erase, LPI_WS_ERASE_ARGS);
lexppro (lsshort, lpi_ws_get_file_count, LPI_WS_GET_FILE_COUNT_ARGS);
lexppro (lsshort, lpi_ws_get_file_name, LPI_WS_GET_FILE_NAME_ARGS);
lexppro (lsshort, lpi_ws_get_file_position, LPI_WS_GET_FILE_POSITION_ARGS);
lexppro (lsshort, lpi_ws_get_indicator_list, LPI_WS_GET_INDICATOR_LIST_ARGS);
lexppro (lsshort, lpi_ws_get_intl_currency, LPI_WS_GET_INTL_CURRENCY_ARGS);
lexppro (lsshort, lpi_ws_set_intl_currency, LPI_WS_SET_INTL_CURRENCY_ARGS);
lexppro (lsshort, lpi_ws_get_intl_date, LPI_WS_GET_INTL_DATE_ARGS);
lexppro (lsshort, lpi_ws_set_intl_date, LPI_WS_SET_INTL_DATE_ARGS);
lexppro (lsshort, lpi_ws_get_intl_negative, LPI_WS_GET_INTL_NEGATIVE_ARGS);
lexppro (lsshort, lpi_ws_set_intl_negative, LPI_WS_SET_INTL_NEGATIVE_ARGS);
lexppro (lsshort, lpi_ws_get_intl_punc, LPI_WS_GET_INTL_PUNC_ARGS);
lexppro (lsshort, lpi_ws_set_intl_punc, LPI_WS_SET_INTL_PUNC_ARGS);
lexppro (lsshort, lpi_ws_get_intl_time, LPI_WS_GET_INTL_TIME_ARGS);
lexppro (lsshort, lpi_ws_set_intl_time, LPI_WS_SET_INTL_TIME_ARGS);
lexppro (lsshort, lpi_ws_get_list_extension, LPI_WS_GET_LIST_EXTENSION_ARGS);
lexppro (lsshort, lpi_ws_set_list_extension, LPI_WS_SET_LIST_EXTENSION_ARGS);
lexppro (lsshort, lpi_ws_get_memory_avail, LPI_WS_GET_MEMORY_AVAIL_ARGS);
lexppro (lsshort, lpi_ws_get_run_autoexec, LPI_WS_GET_RUN_AUTOEXEC_ARGS);
lexppro (lsshort, lpi_ws_set_run_autoexec, LPI_WS_SET_RUN_AUTOEXEC_ARGS);
lexppro (lsshort, lpi_ws_get_save_extension, LPI_WS_GET_SAVE_EXTENSION_ARGS);
lexppro (lsshort, lpi_ws_set_save_extension, LPI_WS_SET_SAVE_EXTENSION_ARGS);
lexppro (lsshort, lpi_ws_string, LPI_WS_STRING_ARGS);
lexppro (lsshort, lpi_ws_get_temp_directory, LPI_WS_GET_TEMP_DIRECTORY_ARGS);
lexppro (lsshort, lpi_ws_set_temp_directory, LPI_WS_SET_TEMP_DIRECTORY_ARGS);
lexppro (lsshort, lpi_ws_update_settings, LPI_WS_UPDATE_SETTINGS_ARGS);
lexppro (lsshort, lpi_ws_get_window_mode, LPI_WS_GET_WINDOW_MODE_ARGS);
lexppro (lsshort, lpi_ws_set_window_mode, LPI_WS_SET_WINDOW_MODE_ARGS);
lexppro (lsshort, lpi_ws_get_window_sync, LPI_WS_GET_WINDOW_SYNC_ARGS);
lexppro (lsshort, lpi_ws_set_window_sync, LPI_WS_SET_WINDOW_SYNC_ARGS);
/* C callable function pointer table */
typedef struct {
     lexpptr (lsshort, lpi_ws_const_current, LPI_WS_CONST_CURRENT_ARGS);
     lexpptr (lsshort, lpi_ws_dest, LPI_WS_DEST_ARGS);
     lexpptr (lsshort, lpi_ws_calc, LPI_WS_CALC_ARGS);
     lexpptr (lsshort, lpi_ws_get_calc_iter, LPI_WS_GET_CALC_ITER_ARGS);
     lexpptr (lsshort, lpi_ws_set_calc_iter, LPI_WS_SET_CALC_ITER_ARGS);
     lexpptr (lsshort, lpi_ws_get_calc_method, LPI_WS_GET_CALC_METHOD_ARGS);
     lexpptr (lsshort, lpi_ws_set_calc_method, LPI_WS_SET_CALC_METHOD_ARGS);
     lexpptr (lsshort, lpi_ws_get_calc_order, LPI_WS_GET_CALC_ORDER_ARGS);
     lexpptr (lsshort, lpi_ws_set_calc_order, LPI_WS_SET_CALC_ORDER_ARGS);
     lexpptr (lsshort, lpi_ws_get_cell_pointer, LPI_WS_GET_CELL_POINTER_ARGS);
     lexpptr (lsshort, lpi_ws_set_cell_pointer, LPI_WS_SET_CELL_POINTER_ARGS);
     lexpptr (lsshort, lpi_ws_get_cell_top_left, LPI_WS_GET_CELL_TOP_LEFT_ARGS);
     lexpptr (lsshort, lpi_ws_set_cell_top_left, LPI_WS_SET_CELL_TOP_LEFT_ARGS);
     lexpptr (lsshort, lpi_ws_get_clock, LPI_WS_GET_CLOCK_ARGS);
     lexpptr (lsshort, lpi_ws_set_clock, LPI_WS_SET_CLOCK_ARGS);
     lexpptr (lsshort, lpi_ws_get_current_file, LPI_WS_GET_CURRENT_FILE_ARGS);
     lexpptr (lsshort, lpi_ws_set_current_file, LPI_WS_SET_CURRENT_FILE_ARGS);
     lexpptr (lsshort, lpi_ws_get_current_sheet, LPI_WS_GET_CURRENT_SHEET_ARGS);
     lexpptr (lsshort, lpi_ws_set_current_sheet, LPI_WS_SET_CURRENT_SHEET_ARGS);
     lexpptr (lsshort, lpi_ws_get_current_window, LPI_WS_GET_CURRENT_WINDOW_ARGS);
     lexpptr (lsshort, lpi_ws_set_current_window, LPI_WS_SET_CURRENT_WINDOW_ARGS);
     lexpptr (lsshort, lpi_ws_get_directory, LPI_WS_GET_DIRECTORY_ARGS);
     lexpptr (lsshort, lpi_ws_set_directory, LPI_WS_SET_DIRECTORY_ARGS);
     lexpptr (lsshort, lpi_ws_erase, LPI_WS_ERASE_ARGS);
     lexpptr (lsshort, lpi_ws_get_file_count, LPI_WS_GET_FILE_COUNT_ARGS);
     lexpptr (lsshort, lpi_ws_get_file_name, LPI_WS_GET_FILE_NAME_ARGS);
     lexpptr (lsshort, lpi_ws_get_file_position, LPI_WS_GET_FILE_POSITION_ARGS);
     lexpptr (lsshort, lpi_ws_get_indicator_list, LPI_WS_GET_INDICATOR_LIST_ARGS);
     lexpptr (lsshort, lpi_ws_get_intl_currency, LPI_WS_GET_INTL_CURRENCY_ARGS);
     lexpptr (lsshort, lpi_ws_set_intl_currency, LPI_WS_SET_INTL_CURRENCY_ARGS);
     lexpptr (lsshort, lpi_ws_get_intl_date, LPI_WS_GET_INTL_DATE_ARGS);
     lexpptr (lsshort, lpi_ws_set_intl_date, LPI_WS_SET_INTL_DATE_ARGS);
     lexpptr (lsshort, lpi_ws_get_intl_negative, LPI_WS_GET_INTL_NEGATIVE_ARGS);
     lexpptr (lsshort, lpi_ws_set_intl_negative, LPI_WS_SET_INTL_NEGATIVE_ARGS);
     lexpptr (lsshort, lpi_ws_get_intl_punc, LPI_WS_GET_INTL_PUNC_ARGS);
     lexpptr (lsshort, lpi_ws_set_intl_punc, LPI_WS_SET_INTL_PUNC_ARGS);
     lexpptr (lsshort, lpi_ws_get_intl_time, LPI_WS_GET_INTL_TIME_ARGS);
     lexpptr (lsshort, lpi_ws_set_intl_time, LPI_WS_SET_INTL_TIME_ARGS);
     lexpptr (lsshort, lpi_ws_get_list_extension, LPI_WS_GET_LIST_EXTENSION_ARGS);
     lexpptr (lsshort, lpi_ws_set_list_extension, LPI_WS_SET_LIST_EXTENSION_ARGS);
     lexpptr (lsshort, lpi_ws_get_memory_avail, LPI_WS_GET_MEMORY_AVAIL_ARGS);
     lexpptr (lsshort, lpi_ws_get_run_autoexec, LPI_WS_GET_RUN_AUTOEXEC_ARGS);
     lexpptr (lsshort, lpi_ws_set_run_autoexec, LPI_WS_SET_RUN_AUTOEXEC_ARGS);
     lexpptr (lsshort, lpi_ws_get_save_extension, LPI_WS_GET_SAVE_EXTENSION_ARGS);
     lexpptr (lsshort, lpi_ws_set_save_extension, LPI_WS_SET_SAVE_EXTENSION_ARGS);
     lexpptr (lsshort, lpi_ws_string, LPI_WS_STRING_ARGS);
     lexpptr (lsshort, lpi_ws_get_temp_directory, LPI_WS_GET_TEMP_DIRECTORY_ARGS);
     lexpptr (lsshort, lpi_ws_set_temp_directory, LPI_WS_SET_TEMP_DIRECTORY_ARGS);
     lexpptr (lsshort, lpi_ws_update_settings, LPI_WS_UPDATE_SETTINGS_ARGS);
     lexpptr (lsshort, lpi_ws_get_window_mode, LPI_WS_GET_WINDOW_MODE_ARGS);
     lexpptr (lsshort, lpi_ws_set_window_mode, LPI_WS_SET_WINDOW_MODE_ARGS);
     lexpptr (lsshort, lpi_ws_get_window_sync, LPI_WS_GET_WINDOW_SYNC_ARGS);
     lexpptr (lsshort, lpi_ws_set_window_sync, LPI_WS_SET_WINDOW_SYNC_ARGS);
} ws_exports;
/* C callable function macros -- use these to call Workspace functions! */
#if defined(LPIXPORT_H)
/* string buffer-length constants (PC only) */
#if (LPI_ENVIRONMENT == LPI_123R3PC)
#define LPI_WS_FILEPATH_BUFLEN 158
#define LPI_WS_DIRPATH_BUFLEN  150
#define LPI_WS_CURRSIGN_BUFLEN 17
#define LPI_WS_FILEEXT_BUFLEN  7
#define LPI_WS_STRING_BUFLEN   10
#endif
#if defined(NOGLOBALDATA)
#define LPI_WS_GLOBAL_REF  LPI_CALL_DATA->ws_global
#define LPI_WS_TABLE_REF   LPI_CALL_DATA->ws_table
#else
#define LPI_WS_GLOBAL_REF  lts_ws_global
#define LPI_WS_TABLE_REF   lts_ws_table
#endif
#define LpiWsConstructCurrent(xADTdata)\
        (*LPI_WS_TABLE_REF->lpi_ws_const_current)\
        (LPI_WS_GLOBAL_REF,xADTdata)
#define LpiWsDestroy(xADTdata)\
        (*LPI_WS_TABLE_REF->lpi_ws_dest)\
        (LPI_WS_GLOBAL_REF,xADTdata)
#define LpiWsCalc(xADTdata)\
        (*LPI_WS_TABLE_REF->lpi_ws_calc)\
        (LPI_WS_GLOBAL_REF,xADTdata)
#define LpiWsGetCalcIterations(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_calc_iter)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetCalcIterations(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_calc_iter)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetCalcMethod(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_calc_method)\
        (LPI_WS_GLOBAL_REF,xADTdata, arg1)
#define LpiWsSetCalcMethod(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_calc_method)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetCalcOrder(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_calc_order)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetCalcOrder(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_calc_order)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetCellPointer(xADTdata, arg1, arg2, arg3, arg4)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_cell_pointer)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1,arg2,arg3,arg4)
#define LpiWsSetCellPointer(xADTdata, arg1, arg2, arg3, arg4)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_cell_pointer)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1,arg2,arg3,arg4)
#define LpiWsGetCellTopLeft(xADTdata, arg1, arg2, arg3, arg4)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_cell_top_left)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1,arg2,arg3,arg4)
#define LpiWsSetCellTopLeft(xADTdata, arg1, arg2, arg3, arg4)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_cell_top_left)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1,arg2,arg3,arg4)
#define LpiWsGetClock(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_clock)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetClock(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_clock)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetCurrentFile(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_current_file)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetCurrentFile(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_current_file)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetCurrentSheet(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_current_sheet)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetCurrentSheet(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_current_sheet)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetCurrentWindow(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_current_window)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetCurrentWindow(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_current_window)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetDirectory(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_directory)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetDirectory(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_directory)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsErase(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_erase)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetFileCount(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_file_count)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetFileName(xADTdata, arg1, arg2)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_file_name)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiWsGetFilePosition(xADTdata, arg1, arg2)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_file_position)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiWsGetIndicatorList(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_indicator_list)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetIntlCurrency(xADTdata, arg1, arg2)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_intl_currency)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiWsSetIntlCurrency(xADTdata, arg1, arg2)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_intl_currency)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiWsGetIntlDate(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_intl_date)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetIntlDate(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_intl_date)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetIntlNegative(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_intl_negative)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetIntlNegative(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_intl_negative)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetIntlPunctuation(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_intl_punc)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetIntlPunctuation(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_intl_punc)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetIntlTime(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_intl_time)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetIntlTime(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_intl_time)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetListExtension(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_list_extension)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetListExtension(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_list_extension)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetMemoryAvail(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_memory_avail)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetRunAutoexec(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_run_autoexec)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetRunAutoexec(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_run_autoexec)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetSaveExtension(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_save_extension)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetSaveExtension(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_save_extension)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsString(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_string)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsGetTempDirectory(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_temp_directory)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetTempDirectory(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_temp_directory)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsUpdateSettings(xADTdata)\
        (*LPI_WS_TABLE_REF->lpi_ws_update_settings)\
        (LPI_WS_GLOBAL_REF,xADTdata)
#define LpiWsGetWindowMode(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_window_mode)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetWindowMode(xADTdata, arg1, arg2)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_window_mode)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiWsGetWindowSync(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_get_window_sync)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#define LpiWsSetWindowSync(xADTdata, arg1)\
        (*LPI_WS_TABLE_REF->lpi_ws_set_window_sync)\
        (LPI_WS_GLOBAL_REF,xADTdata,arg1)
#endif  /* defined(LPIXPORT_H) */
#endif  /* !defined(WKSPACE_PLX) */
